      subroutine strinv(et,erms,exmax,efx,s)
c  given 2-d Cartesian strain components in et (e11, e22, e12),
c  returns the rms extension over 1 2 and 45 deg between them
c  (not invariant), the maximum absolute value of extension,
c  an invariant measure close to erms (the division by 4 does this,
c  at least roughly), and the maximum shear
c
      dimension et(3)
      erms = sqrt((et(1)**2 + et(2)**2 + et(3)**2)/3.)
c find areal strain and max shear
      ea = .5*(et(1) + et(2))
      s = sqrt(0.25*((et(1)-et(2))**2) + et(3)**2)
      exmax = amax1(abs(ea+s),abs(ea-s))
      efx = (et(1)**2 + et(1)*et(2) + et(2)**2 + et(3)**2)/4.
      return
      end
