      subroutine finoff(ifl,itlen,nf,offs)
c  If we have nf data files to be joined, whose file numbers are 
c  in ifl, lengths in itlen, then this subroutine returns in offs the
c  number to be added to the i-th file to make it continuous with
c  the first (offs(1) = 0). To determine the offsets between files,
c  a parabola is fit to the six points surrounding the boundary
c  (actually done as a linear fit of the first differences)
c
c    calls realio, retnio
c
      dimension ifl(nf),itlen(nf),offs(nf),data(6)
      offs(1) = 0.
      if(nf.eq.1) return
      do 5 i = 1,nf-1
      call realio(data,itlen(i)-2,itlen(i),ifl(i),0)
      call realio(data(4),1,3,ifl(i+1),0)
      call retnio(ifl(i))
 5    offs(i+1) = .25*(data(1)-data(6)+5.*(data(4)-data(3)))
      call retnio(ifl(nf))
      do 7 i = 2,nf
 7    offs(i) = offs(i-1) + offs(i)
      return
      end
