      subroutine dtren(x,l)
c      removes mean and linear trend from data, of length l, in array x
c
      dimension x(l)
      double precision w
      s = l
      s11 = 12./(s*(s**2-1.))
      s12 = 6./(s*(s-1.))
      s22 = (2.*(2.*s+1.))/(s*(s-1.))
      v = 0.
      w = 0.
      do 1 i = 1,l
      v = v + x(i)
 1    w = w+ x(i)*i
      a = s22*v - s12*w
      b = s11*w - s12*v
      do 2 i = 1,l
 2    x(i) = x(i) - a - b*i
      return
      end

