      subroutine shelli(ix,k,n)
c  sorts an array ix, of length n, sorting upward, and returns
c  an array k which may be used to key another array to the
c  sorted pattern (i.e., if we had an array jf to which ix
c  corresponded before sorting, then after calling shells,
c  jf(k(1)) will be the element of f corresponding to the
c  smallest ix, jf(k(2)) the next smallest, and so on.
c
c    calls no other routines
c
      dimension ix(n),k(n)
      igap = n
      do 1 i = 1,n
 1    k(i) = i
 5    if(igap.le.1) return
      igap = igap/2
      imax = n - igap
 10   iex = 0
      do 20 i = 1,imax
      ipl = i + igap
      if(ix(i).le.ix(ipl)) go to 20
      isv = ix(i)
      ik = k(i)
      ix(i) = ix(ipl)
      k(i) = k(ipl)
      ix(ipl) = isv
      k(ipl) = ik
      iex = iex + 1
 20   continue
      if(iex.gt.0) go to 10
      go to 5
      end
