
filnumchk(number)
/*  Checks the legality of a file number (see the comments in munman)  */
/*  and returns  */
/*    -1 for real files  */
/*     1 for short integer files  */
/*     2 for long integer files  */
/*     0 for illegal numbers  */
int number;
{
   int type,num;
   int pnum,thous;
   num = abs(number);
   pnum = num/10000;		/*tens of thousands (or more)*/
   thous = num/1000 - 10*pnum;	/*thousands digit*/
   if(num%1000<100 || thous >3 || (number<0 && (thous ==1 || thous > 2))
               || (pnum>0 && number > 0 && thous >1)
               || (pnum>0 && number < 0 && thous >0))
      type = 0;
   else if (number>0 && thous%2 == 0)
      type = 1;
   else if (number>0 && thous%2 == 1)
      type = 2;
   else if (number<0)
      type = -1;
   return(type);
}
