      subroutine filcop(ifin,irli,irhi,ifout,irlo)
c  copies data from file ifin, terms irli through irhi, to file ifout
c  starting at term irlo. files may be real or integer. if going from
c  real to integer, values are rounded
c
c   $$$calls realio, intio
c
      dimension x(600),ix(600)
      irl1 = irli
      irl2 = irlo
 1    irh1 = min0(irl1+59,irhi)
      np = irh1 - irl1 + 1.
      irh2 = irl2 + (irh1-irl1)
      if(ifout.lt.0.or.ifin.lt.0) call realio(x,irl1,irh1,ifin,0)
      if(ifout.lt.0) call realio(x,irl2,irh2,ifout,-1)
c convert to integer
      if(ifin.lt.0.and.ifout.gt.0) then 
         do 3 i=1,np
 3       ix(i) = nint(x(i))
      endif
      if(ifin.gt.0.and.ifout.gt.0) call intio(ix,irl1,irh1,ifin,0)
      if(ifout.gt.0) call intio(ix,irl2,irh2,ifout,-1)
      irl1 = irh1+1
      irl2 = irh2+1
      if(irl1.le.irhi) go to 1
      return
      end
      subroutine linter(ifile,irl,irh)
c  replace data in file ifile, terms irl+1 through irh-1, with a linear
c  interpolation between the values at irl and irh.  interpolation is done
c  in real, with rounding to integer if needed
c
c  $$$$calls realio,intio
c
      dimension x(600),ix(600)
      if(irh-irl.le.1) return
      if(ifile.gt.0) call intio(ist,irl,irl,ifile,0)
      if(ifile.gt.0) call intio(ien,irh,irh,ifile,0)
      st = ist
      en = ien
      if(ifile.lt.0) call realio(st,irl,irl,ifile,0)
      if(ifile.lt.0) call realio(en,irh,irh,ifile,0)
      slp = (en-st)/(irh-irl)
      irlo = irl+1
 1    irho = min(irlo+599,irh-1)
      np = irho - irlo + 1
      do 3 i=1,np
      x(i) = st + slp*(irlo+i-irl-1)
 3    ix(i) = nint(x(i))
      if(ifile.gt.0) call intio(ix,irlo,irho,ifile,-1)
      if(ifile.lt.0) call realio(x,irlo,irho,ifile,-1)
      irlo = irho + 1.
      if(irlo.le.irh-1) go to 1
      return
      end
