#include "niostf.h"

longis_(number)
/*  for a given libnio file (specifed by number) returns the length,
    or -1 if the file could not be found or has a different owner and
    is not read-permitted    */

int *number;
{
   int num,ib,terms;
   char filnam[NAMLEN];
   struct stat finfo;
   num = *number;
   ib = filnumchk(num);
   if(ib==0)
      return(-1);             /*error return on illegal file number*/
   munman(num,filnam);
   if(stat(filnam,&finfo)==-1)
      return(-1);             /*error return on failed status request*/
   else if( (getuid()!=finfo.st_uid) && ((finfo.st_mode&04)==0) )
      return(-1);             /*error return on no read permission*/
   else{
      if(ib==-1 || ib == 2)
         terms = (finfo.st_size - OFFSET)/4;     /*real or long integer*/
      else if(ib== 1)
         terms = (finfo.st_size - OFFSET)/2;     /*short integer*/
      else
         terms = -1;
   }
   return(terms);
}
