#include <stdio.h>
/********GETWORD          
* This function will read the next word from a file and return it in the
* pointer theword.  The character immediately following the word found is
* the return value of the function.  A word is terminated by any of the   
* following   * : , [tab] [space] [endofline] 
**********************/
int getword(theword,thefile)
char * theword;FILE* thefile;
{
char c;
int i=0;
c=0;
while(c!='\t'&&c!='*'&&c!=':'&&c!=' '&&c!='\n'&&c!=EOF&&c!=','){
   c=fgetc(thefile);
   theword[i]=(char) c;
   i++;
}
theword[i-1]=0;
return c;
}


/******GETPIN
* This function will read from the file given until it sees a letter or 
* number. From that point, it will read three more characters.  The pin
* returned is the four letters.
********************************/
int getpin(thepin,thefile)
char *thepin;FILE* thefile;
{
char c;
int i;
c=0;
while(c<33) {c=fgetc(thefile);if(c==EOF) return 0;}
thepin[0]=c;
for(i=1;i<4;i++) {
   c=fgetc(thefile);
   if(c==EOF) return 0;
   thepin[i]=(char) c;
   }
	
thepin[4]=0;
return 1;
}


/******SKIPUNTIL
* This routine skips through the given file until the given char is found.
* It then throws away this character and returns.
**********************/
int skipuntil(thechar,thefile)
char thechar;FILE* thefile;
{
char c=0;
while(c!=thechar&&c!=EOF) c=fgetc(thefile);
}


/******SKIPTOWORD
* This routine skips through the given file until the given word is found.
* It is thrown away.  The last char in the word is returned.
************************/
int skiptoword(theword,thefile)
char theword[30];FILE* thefile;
{
char oneword[80];
int c,i;
do{
	c=getword(oneword,thefile);
        i=strcmp(oneword,theword);
 	if(c==EOF) break;
  }
while(i!=0);
return c;
}
