      subroutine dodeco(idood,ict)
      character*6 idood
      dimension ict(6)
c  given the Doodson number of a tidal constituent in Doodson's format
c  (all values but the first biased by 5, and X and E used for 10 and
c  11), returns the number in Cartwright-Tayler form, in the array ict.
c   Doodson code is in character block idood
c
      ict(1) = idcd(idood(1:1))
c  all but the first code is biased down by 5
      do 3 i = 2,6
      ict(i) = idcd(idood(i:i)) -5
 3    continue
      return
      end
      function idcd(ichar)
c  returns the numeric value of a character (0-9), with 10 for X and 11 for E
      character*1 idcod,ichar
      dimension idcod(12)
      data idcod/'0','1','2','3','4','5','6','7','8','9','X','E'/
      do 3 i=1,12
      if(ichar.eq.idcod(i)) go to 5
 3    continue
      if(ichar.eq.'x') idcd = 10
      if(ichar.eq.'e') idcd = 11
      if(ichar.eq.'e'.or.ichar.eq.'x') return
c  error return
      idcd = -1
      return
 5    idcd = i - 1
      return
      end
