c  crecho
c   program for looking at data on tektronix, "echoing" what credit is
c   looking at in another window
c   Takes two command-line arguments:
c       number of data file
c       number of edits file (optional)
c
c     link with credsubs, dshoget, curs, xedit, secdat, predic, grafic,dumio
c
      character*20 dumm
      logical iblank,allblk,blnkit,sync
      integer ioff
      dimension x(1020)
c   block containing information on series displayed (see shoget)
      common/sam/itl,ith,idec,ie,ymin,ymax,isc,ifil,irntot
c   block containing control information for screen printing
      common/tkcon/isp,nmsec
c   block containing edit commands (see xedit)
      common/edits/igap(2,4000),ioff(4000),ned,irlp,ifp
c   block containing information about blanking the plot
      common/fade/iblank(1020),allblk,blnkit,sync
c   block containing information to be passed to fedcon
      common/minedt/mlen
c
      data blnkit/.true./,sync/.false./,isc/1/,ned/0/,mlen/480/,
     1  iedf/0/,idebt/0/,ers/1./,ifirntt/0/
c   get information off command line
      if(iargc().lt.1.or.iargc().gt.2) then
        write(6,100)
  100   format(' Usage:  crecho data-file [edits-file]')
        stop
      endif
      call getarg(1,dumm)
      read(dumm,102) ifil
  102 format(i20)
      irntot=longis(ifil)
      if(iargc().gt.1) then
        call getarg(2,dumm)
        read(dumm,102) iedf
        ned = 4000
        call fedcon(ned,igap,ioff,1,ifirntt,iedf)
      endif
  5   call crsync(itl,ith,iedtot,-1)
      if(ith.ne.itho.or.itl.ne.itlo.or.iedtot.ne.iedo) then
        if (idebt.eq.1) then
          call dshoget(x,ers,ned*iedf)
        else
          call shoget(x,ers,ned*iedf)
        endif
        itho=ith
        itlo=itl
        iedo=iedtot
        if(ifirntt.gt.0) call showedits(iedf,ifirntt)
      endif
c sleep for 0.2 sec
      call musleep(200000)
      go to 5
      stop
      end
