c     datred.for
c     reads and lists,printer plots, or graphic plots data that has
c     been stripped and put on disk
c      data can be decimated.
c     calls subroutines prqt,tkplot,xycnvt,toutpt,ccplt
c          link with prqt,tkplot,sendeg,libnio
c
c   ****note that questions are sent to error output to allow
c       redirection of standard output in options 1 and 4 
c
c     latest version   august 8 1985
      character*1 not
      integer order1,order2
c
      common/sam/irbs,ires,ierase,iich
      real idec
      logical complx,amp
      dimension data(1020),buf(1020),idata(1020)
      dimension check(2)
      k=0
      ierase=0
      xendpl=1.
      iq=1
      iqq=1
   30 write(6,300)
  300 format(' Data file to examine    ; ',$)
      iich=ffin(1,not)
      if(iich.eq.0) then
        write(6,301)
 301    format(/)
        stop
      endif
      imm=1
      write(6,360)
  360 format(' Decimation factor       ; ',$)
      idec=ffin(1,not)
      complx= (idec.eq.-2.0)
      mmplot=0
      if(idec.lt.-2.0) mmplot=1
      idec= abs(idec)
  329 write(6,330)
  330 format(' Output mode (h for help); ',$)
      iopt=ffin(1,not)
      if(iopt.eq.5) go to 48
      if(iopt.eq.-3.or.(iopt.le.4.and.iopt.ge.1)) go to 333
      if(not.ne.'h') go to 329
      write(6,331)
 331  format(' Output modes are:',/,12x,
     1 ' 1 - list numbers on terminal',/,12x,
     2 ' 2 - printer plot',/,12x,
     3 ' 3 - tektronix plot (-3 for overplot)',/,12x,
     4 ' 4 - output for graph',/,12x,
     5 ' 5 - give length of file, no list')
      go to 329
c
c   set ierase=1 to kill screen erase
c
  333 if(iopt.le.0) ierase = 1
      iopt=iabs(iopt)
  319 write(6,320)
  320 format(' Start and end terms     ; ',$)
      irs1=ffin(1,not)
      if(irs1.le.0) go to 30
      irs2=ffin(1,not)
      ires=irs1-1
      amp= (mod(irs1,2).eq.1)
      if (complx.and.mod(irs2,2).eq.1) irs2=irs2-1
      if (complx.and.(.not.amp)) irs1=irs1-1

   10 if(iopt.eq.1) imm = 0
      if(iopt.eq.1.or.iopt.ge.4) go to 20
   21 write(6,340)
  340 format(' Plot limits             ; ',$)
      rymin=ffin(1,not)
      rymax=ffin(1,not)
      if(rymin.lt.rymax)imm=0
c      imm=0 means that limits are given
   20 continue
c    all questions are now answered
      ilab=1
      ii=1
      j=1
      if(imm.eq.0.or.iopt.eq.1.or.iopt.ge.3) go to 18
c
c    take this branch and scan all data for limits
c             (in 1985 revision used only for printer plot)
      iiii=1
      ix2=irs1-1
 700  ix1=ix2+1
      ix2=ix1+1019
      ix2=min0(ix2,irs2)
      ii=1
      itotal=ix2-ix1+1
      call realio(buf,ix1,ix2,iich,0)
  100 data(ii)=buf(j)
      if (.not. complx) go to 1001
      if (amp) data(ii)=sqrt(buf(j)**2+buf(j+1)**2)
      if(.not.amp)data(ii)=57.29578*atan2(buf(j+1),buf(j)+1.0e-30)
 1001 continue
      if (iiii.eq.2) go to 380
      rymin=data(1)
      rymax=data(1)
      iiii=2
  380 rymin=amin1(data(ii),rymin)
      rymax=amax1(data(ii),rymax)
      ii=ii+1
      j=j+idec
      if(mmplot.eq.1) j=(j-idec)+1
      if(j.le.itotal) go to 100
      j=mod(j,1020)
      if(ix2.lt.irs2) go to 700
 18   continue
c    now have min,max for sure.
c
c    get a buffer load
c
      ii=1
      j=1
      ix2=irs1-1
703   j=mod(j,1020)
      ix1=ix2+1
      ix2=ix1+1019
      ix2=min0(ix2,irs2)
      itotal=ix2-ix1+1
      call realio(buf,ix1,ix2,iich,0)
   24 data(ii)=buf(j)
      if (.not.complx) go to 2401
      if (amp) data(ii)=sqrt(buf(j)**2+buf(j+1)**2)
      if(.not.amp)data(ii)=57.29578*atan2(buf(j+1),buf(j)+1.0e-30)
2401  continue
      if(rymin.ge. rymax .or. iopt.eq.1.or.iopt.eq.2) go to 25
      data(ii)=amin1(data(ii),rymax)
      data(ii)=amax1(data(ii),rymin)
 25   if(mmplot.eq.0) go to 125
      k=k+1
      if(k.gt.1) go to 900
      check(1)=data(ii)
      check(2)=data(ii)
      order1= k
      order2=k
      go to 901
900   check(1)=amin1(check(1),data(ii))
      check(2)=amax1(check(2),data(ii))
      if(check(1).eq.data(ii))order1=k
      if(check(2).eq.data(ii))order2=k
      if(k.lt.int(idec)) go to 901
      if(order1.lt.order2)data(ii)=check(1)
      if(order1.lt.order2) data(ii+1)=check(2)
      if(order2.lt.order1) data(ii)=check(2)
      if(order2.lt.order1) data(ii+1)=check(1)
      ii=ii+2
      k=0
901   j=j+1
      go to 126
  125 ii=ii+1
      j=j+idec
126   ie=ii-1
      if(ii.gt.1020) go to 41
      go to 23
 22   if(ix2.ge.irs2) go to 349
 23   if(j.le.itotal) go to 24
      if(ix2.lt.irs2) go to 703
 41   ii=1
c
c    now we have a buffer load
c
      go to (40,42,44,46,22)iopt
c
c    option 1 (list data)
c
 40   if (iich.lt.0) go to 704
      do 705 i=1,ie
  705 idata(i)=data(i)
      if(mod(iich,10000).gt.1000) write(6,199)(idata(i),i=1,ie)
  199 format(1x,5i12)
      if(mod(iich,10000).lt.1000) write(6,200)(idata(i),i=1,ie)
  200 format(1x,10i7)
      go to 22
  704 write(6,201)(data(i),i=1,ie)
  201 format(1x,5g15.5)
      go to 22
c
c      option 2 - printer plotter
c
   42 call prqt(data,1,ie,rymin,rymax)
      go to 22
c
c      option 3 - tektronix plot
c
c       irbs and ires passed thru common
c       should be first  last   original term numbers
c       (if these are the same, do not make a plot, but silently skip)
c
   44 irbs=ires+1
      ires=(irbs-1)+ie*idec
      ires=min(ires,irs2)
      if(ires.ne.irbs) call tkplot(data,1,ie,rymin,rymax)
      go to 22
c
c  option 4 - write out pairs of points for Unix graph utility
c
 46   ndec = idec
      if(complx) ndec=1
      irbs = ires + 1
      ires = irbs + ndec*ie -1
      do 710 i=1,ie
      write(6,202) irbs+ndec*(i-1),data(i)
 202  format(i9,g14.6)
 710  continue
      if(ix2.ge.irs2) write(6,203) irbs+ndec*(ie-1),data(ie)
 203  format(i9,g18.10,'" "')
      go to 22
 349  call retnio(iich)
      go to 319
c
c
c
 48   length = longis(iich)
      if(length.ge.0) write(6,222) iich,length
 222  format(' File ',i7,' is ',i8,' terms long')
      if(length.lt.0) write(6,223) iich
 223  format(' File ',i7,' does not exist or is unreadable')
      call retnio(iich)
      go to 30
      end
