c  program stpmon
c   for a given dislocation source, reads in a file of monuments,
c and writes it out with the response prepended-may do for several
c responses
c
c   $$$calls segget,stpsub,topo,fdefor,stran,van
c
c
      character*1 iobs
      character*40 filnam
      character*80 line,monfile
      dimension e1(3),t1(3),d1(3),e2(3),t2(3),d2(3)
      dimension e2t(3),t2t(3),d2t(3)
      write(6,100)
 100  format(' File of monuments ;; ',$)
      read(5,*) monfile
      luin = 3
      open(luin,file=monfile,status='old')
c get fault information
      call segget(nsegs)
 3    write(6,102)
 102  format(' Azimuth (if needed) and type of datum (h for help) ; ',$)
      dir = ffin(1,iobs)
      if(dir.ne.666) dir = 180-dir
      if(iobs.eq.'x') go to 9
      if(iobs.eq.'h') write(6,104)
 104  format(' Types of data allowed are:',/,5x,
     1 '   z - vertical displacement',/,5x,
     2 'nnnd - horizontal displacement at azimuth nnn',/,5x,
     3 '       (azimuth of 666 means max displacement)',/,5x,
     4 'nnnl - extension at azimuth nnn',/,5x,
     5 '       (azimuth of 666 means max extension)',/,5x,
     6 '   v - volume strain (for poisson''s ratio 0.25)',/,5x,
     7 'nnns - shear strain at azimuth nnn',/,5x,
     8 'nnnt - tilt at azimuth nnn',/,5x,
     9 '       (azimuth of 666 means max tilt)',/,5x,
     1 '   b - rotation (change in azimuth)',/,5x,
     1 '   r - rms extension ',/,5x,
     1 '   x - exit from program')
      if(iobs.eq.'h') go to 3
      scale = 1.e9
      if(iobs.eq.'z'.or.iobs.eq.'d') scale = 1000
      write(6,106)
 106  format(' Name of output file ;; ',$)
      read(5,*) filnam
      lu = 1
      open(lu,file=filnam,status='unknown')
c
c  loop over each line of monument list
c
 5    read (luin,108,end=7) line
 108  format(a80)
      read(line,110)rlat,rlong
 110  format(6x,f8.4,f11.4)
c set parameters to zero, in preparation for summing over fault segments
      do l=1,3
        d2(l)=0
        e2(l)=0
        if(l.lt.3) t2(l)=0
      enddo
c first call to segget gets parameters, second steps through fault segments,
c with a loop to the beginning (so we can call this routine nseg times for
c each point)
      do k=1,nsegs
        call segget(nsegs)
        call stpsub(rlat,rlong,e2t,t2t,d2t)
        do l=1,3
          d2(l)=d2(l)+d2t(l)
          e2(l)=e2(l)+e2t(l)
          t2(l)=t2(l)+t2t(l)
        enddo
      enddo
      call strinv(e2,erms,exmax,efx,shmax)
      if(iobs.eq.'z') xres = d2(3)
      if(iobs.eq.'r') xres = erms
      if(iobs.eq.'v') xres = .6667*(e2(1)+e2(2))
      if(iobs.eq.'b') x = t2(3)
      if(dir.ne.666) then
         call van(d2,dir,d1)
         call van(t2,dir,t1)
         call stran(e2,dir,e1)
         if(iobs.eq.'d') xres = d1(1)
         if(iobs.eq.'t') xres = t1(1)
         if(iobs.eq.'l') xres = e1(1)
         if(iobs.eq.'s') xres = e1(3)
      else
         if(iobs.eq.'d') xres = sqrt(d2(1)**2 + d2(2)**2)
         if(iobs.eq.'t') xres = sqrt(t2(1)**2 + t2(2)**2)
         if(iobs.eq.'l') xres = exmax
         if(iobs.eq.'s') xres = shmax
      endif
      write(lu,114) xres,line
 114  format(f12.3,2x,a80)
      go to 5
 7    continue
c go back for another quantity
      close(lu)
      rewind(luin)
      go to 3
c done
 9    close(luin)
      stop
      end
