      subroutine getich(file)
c
c   subroutine to get the header information for an Ice-9 datalogger file
c     information is passed back to main program in common blocks
c
c   the argument  file   is the file name
c
      character*(*) file
      character*8 source,chanid
      character*4 stc,commen,ctmp,ho
      character*1 tochar
      double precision scans
      integer*2 lf,lenstr
      integer*2 lbuf
      logical*1 timlim,shift
      dimension ihbuf(32),ihbuf2(32),ihbuf3(4),lbuf(64)
      common/times/jstart(5),jend(5),ioff,intval,timlim,shift
      common/lengt/nbhed,nblasc,nbfinl
      common/miscel/nver,ipadd(4),isft(4)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      equivalence (lbuf(1),ihbuf(1))
      data ho/'////'/
c
c read the header
c
      lf=lenstr(file)
      call byteio(lbuf,1,128,file,lf,0)
c
c swap the data from PC to workstation order
c
      call swap4(32,ihbuf,ihbuf2)
      if(ihbuf2(1).eq.1.and.intval.eq.0) then
         write(6,100)
 100     format('Version-1 data files must have the sample interval',
     1 ' on the command line')
         stop
      endif
      nver=ihbuf2(1)
      nbhed=ihbuf2(2)
      nbfinl=ihbuf2(3)
      nblasc=ihbuf2(4)
c
c   next two lines deal with 2-byte sample time
c
      call gbytes(ihbuf2(6),ihbt,16,16,0,1)
      if(ihbuf2(1).ne.1) intval=ihbt
c
c   unpack the datalogger ID, and fill three locations with it
c
      call gbytes(ihbuf(5),ihbuf3,0,8,0,4)
      do i=1,3
       stc(i:i)=tochar(ihbuf3(i))
       source(i:i)=tochar(ihbuf3(i))
       ctmp(i:i)=tochar(ihbuf3(i))
      enddo
      ctmp(4:4)=char(ihbuf3(4))
      commen(1)=ctmp
      commen(21)=ho
c
c   unpack the IP address, which is 4 bytes.
c
      call gbytes(ihbuf(7),ipadd,0,8,0,4)
c
c   unpack the software version, which is 4 bytes.
c
      call gbytes(ihbuf(8),isft,0,8,0,4)
c
c   unpack the logger ID, which is 4 characters
c
      call gbytes(ihbuf(9),ihbuf3,0,8,0,4)
      do i=1,4
       ctmp(i:i)=tochar(ihbuf3(i))
      enddo
      commen(3)=ctmp
      return
      end
      function tochar(n)
      character*1 tochar
      if(n.ge.32.and.n.le.126) then
         tochar=char(n)
         return
      endif
      tochar=' '
      return
      end
