      program gsedit
c
c   takes a data series in which bad points are "flagged" by being set
c  to some large value and produces an edits file for it.  the rule
c  used for finding bad points is that they exceed some value, either
c  in a positive or negative direction
c   the program also asks for the offset value
c
c    calls edcon (editlb), iolib
c
      dimension x(600),igap(2,64000),ioff(64000)
      character*1 ipl,imn,ilmdr,not
      data iedfl/0/,igap/128000*0./,ioff/64000*0/,mul/1/,ned/1/,irl/1/
     1 ipl/'+'/,imn/'-'/
      write(6,102)
 102  format(' data file and length; ',$)
      ifl = ffin(1,not)
      irnt = ffin(1,not)
      if(irnt.le.0) irnt = longis(ifl)
 3    write(6,104)
 104  format(' flag values above (+) or below (-) limit level?;; ',$)
      read(5,105) ilmdr
 105  format(a1)
      if(ilmdr.ne.ipl.and.ilmdr.ne.imn) go to 3
      write(6,106)
 106  format(' limit level; ',$)
      flg = ffin(1,not)
      write(6,107)
 107  format(' offset value; ',$)
      ioval = ffin(1,not)
      do 11 i=1,64000
      ioff(i) = ioval
 11   continue
      if(ilmdr.eq.imn) mul = -1
      flg = mul*flg
 7    irh = min0(irl+599,irnt)
      call realio(x,irl,irh,ifl,0)
      np = irh - irl + 1
      do 13 i=1,np
      itn = irl + i - 1
      xs = mul*x(i)
c   if datum is ok, set "last good point" to the term number. if it
c   is not, set a flag, and on finding the next good point, put the 
c   term number into the "first good point", increment the edit count,
c   and reset the flag
      if(xs.gt.flg) iedfl = 1
      if(xs.le.flg.and.iedfl.eq.1) igap(2,ned) = itn
      if(xs.le.flg.and.iedfl.eq.1) ned = ned + 1
      if(xs.le.flg)                iedfl = 0
      if(xs.le.flg)                igap(1,ned) = itn
 13   continue
      irl = irh + 1
      if(irl.le.irnt) go to 7
c  if last point ok, decrement edit counter, else set end of bad
c  data to be last term (even though this datum is bad)
      if(xs.le.flg) ned = ned - 1
      if(xs.gt.flg) igap(2,ned) = itn
      call retnio(ifl)
      write(6,120) ned
 120  format(i7,' edits total')
      call edcon4(ned,igap,ioff,-1,irnt)
      stop
      end
