c$$$$$ calls splineq and evaleq
c  generates an equally-spaced interpolated file at an arbitrary
c  spacing from a given equally-spaced data file.  uses cubic-spline
c  interpolation.  data series is broken into blocks no longer than
c  2000 terms long in input file or the corresponding output.  an
c  overlap of  2  terms is maintained between consecutive input
c  blocks to help continuity of derivatives.
      character*1 not
      common // xx(2),x(2000),s(2002),y(2001),iy(2001)
      double precision tt,dtt
c
 1000 write(6,100)
 100  format(' enter file of data to be interpolated; ',$)
      infil=ffin(1,not)
 105  format(5i10)
      write(6,110)
 110  format(' enter output file; ',$)
      iout = ffin(1,not)
      write(6,120)
 120  format(' enter begin, end term numbers for input; ',$)
      it1=ffin(1,not)
      it2=ffin(1,not)
      if(it2.le.0) it2=longis(infil)
c
      write(6,130)
 130  format(' enter spacing of interpolated data; ',$)
      dt = ffin(1,not)
 125  format(5f10.0)
      write(6,140)
 140  format(' enter  x  value of first output point'/
     &' (this is  1  to begin at ist term of old series'/
     &' 2  at the second,  1.5 for half-way between, etc); ',$)
      tstart = ffin(1,not)
c
       tt=tstart
      dtt=dt
       ndispl=0
      iot=1
      irec=1
      iblock=aint(amin1(2000.0,2000.0/dt))
c
      do 2500 it0=it1,it2,iblock
      itend=min(it2,it0 + iblock -1)
      call realio(x,it0,itend,infil,0)
C      write(6,210)
C 210  format(' input block read in ')
      npts=itend - it0 + 1
      call splneq(npts-ndispl,xx(ndispl+3),s)
c
 2100 do 2200 it=1,2001
      t=tt - it0 + 1.0
      y(it)=evaleq(t - ndispl,npts-ndispl,xx(ndispl+3),s)
      tt=tt + dtt
      if (tt .gt. itend) go to 2400
 2200 continue
      it=2001
c
 2400 continue
      iot1=iot+it-1
      if(iout.gt.0) then
	 do 2450 kkk = 1,it
 2450    iy(kkk) = nint(y(kkk))
         call intio(iy,iot,iot1,iout,irec)
      endif
      if(iout.lt.0) call realio(y,iot,iot1,iout,irec)
      iot=iot+it
      if (tt.lt.itend-0.5*dt) go to 2100
      xx(1)=x(npts-1)
      xx(2)=x(npts)
      ndispl=-2
 2500 irec=-1
c
      write(6,255) iot1
 255  format(i8,' points written out ')
      stop
      end
