c   program interp2 - reads in x-y pairs, and writes out equally-spaced
c  interpolates to a realio file. Input file must be in increasing x-order
c
      character*100 infl
      character*1 not
      dimension x(10000),y(10000),out(500),s(10000),a(10000)
      data lui/1/,n/1/,irl/1/
      write(6,100)
 100  format(' Input file name; ',$)
      read(5,*) infl
      write(6,*) infl
      open(lui,file=infl)
      write(6,102)
 102  format(' Output file number; ',$)
      iofl = ffin(1,not)
      write(6,104)
 104  format(' Output file x-limits and spacing; ',$)
      xl = ffin(1,not)
      xu = ffin(1,not)
      d = ffin(1,not)
      nt = nint((xu-xl)/d) + 1
 3    read(lui,*,end=5) x(n),y(n)
      n = n + 1
      go to 3
 5    n = n - 1
      close(lui)
      call spline(n,x,y,s,a)
 7    irh = min(irl+499,nt)
      ms = irh - irl + 1
      do 9 j=1,ms
      xc = xl + (irl+j-2)*d
      out(j) = eval(xc,n,x,y,s)
 9    continue
      call realio(out,irl,irh,iofl,1)
      irl = irh + 1
      if(irl.le.nt) go to 7
      write(6,106) n,irh
 106  format(' From ',i6,' irregular points found ',i8,' regular ones')
      stop
      end
