c  program levshf
c   adjusts the level of an edited file to match another file from
c  which it was produced, putting the corrections inside the edits
c  as slopes.
c
c     calls edcon
c
      character*1 izcr,not,style,ifma
      dimension gp(2,200),iof(200),idat(600)
      data ned/200/,corr,corr2/2*0.0/
      write(6,100)
 100  format(' Original file and its length ',$)
      iorg = ffin(1,not)
      irnt = ffin(1,not)
      rnt = irnt
      write(6,102)
 102  format(' Data file in (edited) ',$)
      ifix = ffin(1,not)
      write(6,103)
 103  format(' Data file out (0 to overwrite) ',$)
      iout = ffin(1,not)
      if(iout.eq.0) iout = ifix
      if(iout.ne.ifix) call intio(idat,1,1,iout,1)
      call edcon(ned,gp,iof,1,rnt)
      write(6,104)
 104  format(' Correct to absolute level (a) or match offsets (o)? ',$)
      idum = ffin(1,style)
      if(style.eq.'o') then
         write(6,106)
 106     format(' Correct all gaps (a), or only offsets (o) ',
     1 'or glitches (g)? ',$)
         idum = ffin(1,izcr)
         if(izcr.eq.'o') then
c  remove glitch edits from edit list
            k=1
 21         if(iof(k).eq.0.and.k.lt.ned) then
               ned = ned - 1
               do 23 j=k,ned
               gp(1,j) = gp(1,j+1)
               gp(2,j) = gp(2,j+1)
               iof(j) = iof(j+1)
 23            continue
            else if(iof(k).ne.0.and.k.lt.ned) then
               k = k + 1
            endif
            if(k.lt.ned) go to 21
            if(k.eq.ned.and.iof(k).eq.0) ned = ned - 1
            write(6,107) ned
 107        format(2x,i5,' offsets in edits file')
            if(ned.le.0) stop
         endif
         if(izcr.eq.'g') then
c  remove offset edits from edit list
            k=1
 25         if(iof(k).ne.0.and.k.lt.ned) then
               ned = ned - 1
               do 27 j=k,ned
               gp(1,j) = gp(1,j+1)
               gp(2,j) = gp(2,j+1)
               iof(j) = iof(j+1)
 27            continue
            else if(iof(k).eq.0.and.k.lt.ned) then
               k = k + 1
            endif
            if(k.lt.ned) go to 25
            if(k.eq.ned.and.iof(k).ne.0) ned = ned - 1
            write(6,1075) ned
 1075       format(2x,i5,' glitches in edits file')
            if(ned.le.0) stop
         endif
         write(6,108)
 108     format(' offset first term to make values match',
     1       ' there (y/n) ',$)
         idum = ffin(1,ifma)
      endif
c  loop through edits, finding the incremental offset
c  if 'independent', each section of good data is offset to be at the
c  level of the original (the edits file must be complete in this case)
c  if 'cumulative', offsets across each edit will be made to be what
c  they were in the original, and so are accumulated through the data;
c  this is appropriate for removing spurious offsets introduced by
c  an interpolating process. This may involve only some edits.
      do 13 i=1,ned
c  first do the section of data before the edit (for i=1, from the
c  start to this point)
      if(i.eq.1) irl = 1
      if(i.ne.1) irl = gp(2,i-1)
      irht = gp(1,i)
      if(style.eq.'a'.or.(style.eq.'o'.and.ifma.eq.'y'.and.i.eq.1))then
         call intio(icorr,irl,irl,iorg,0)
         call intio(iwrng,irl,irl,ifix,0)
         corr = icorr - iwrng
      endif
 3    irh = min(irl+599,irht)
      nt = irh - irl + 1
      call intio(idat,irl,irh,ifix,0)
      iwbg = idat(nt)
      do 5 j=1,nt
 5    idat(j) = idat(j) + corr
      call intio(idat,irl,irh,iout,-1)
      irl = irh + 1
      if(irl.le.irht) go to 3
c  get correction after edit and put in slope to make sides match up
      irl = gp(1,i) + 1
      irht = gp(2,i)
      if(style.eq.'a') then
        call intio(icorr,irht,irht,iorg,0)
        call intio(iwrng,irht,irht,ifix,0)
        corr2 = icorr - iwrng
        slp = (corr2-corr)/(irht-irl+1)
      else if(style.eq.'o') then
        call intio(icbg,irl-1,irl-1,iorg,0)
        call intio(icen,irht,irht,iorg,0)
        call intio(iwen,irht,irht,ifix,0)
c  offset to introduce is correct one minus existing (wrong) one
        corr2 = (icen-icbg) - (iwen-iwbg)
        slp = corr2/(irht-irl+1)
      endif
      irht = irht - 1
 9    irh = min(irl+599,irht)
      nt = irh - irl + 1
      call intio(idat,irl,irh,ifix,0)
      do 11 j=1,nt
 11   idat(j) = idat(j) + corr + slp*(j+irl-gp(1,i)-1.)
      call intio(idat,irl,irh,iout,-1)
      irl = irh + 1
      if(irl.le.irht) go to 9
      if(style.eq.'o') corr = corr + corr2
 13   continue
c put correction in final segment (to end of file)
      if(style.eq.'a') corr = corr2
      irl = gp(2,ned)
 15   irh = min(irl+599,irnt)
      nt = irh - irl + 1.
      call intio(idat,irl,irh,ifix,0)
      do 17 j=1,nt
 17   idat(j) = idat(j) + corr
      call intio(idat,irl,irh,iout,-1)
      irl = irh + 1
      if(irl.le.irnt) go to 15
      write(6,110) irh
 110  format(i8,' terms processed')
      stop
      end
