        program stats
c$$$$$$$ link with iolib
c  program for finding mean,standard deviation and max,min of
c  an arbitrary series from disk file
c
c  double precision added  Apr 25 2008
c
        character*1 not
	double precision wdotu,r,u1,d,rnorm
	dimension x(600),ix(600),infile(32)
	data buf/600.0/
	data nfiles/-1/
c
     	write(6,100)
 100	format(' Data files (end with 0)::; ',$)
	call listin(infile,nfiles,0)
c
	write(6,110)
 110	format(' Begin, end term numbers, decimation integer; ',$)
        iix1 = ffin(1,not)
        ix2 = ffin(1,not)
c  if term numbers in reverse order, second is set to length of first file
        if(ix2.lt.iix1) ix2=longis(infile(1))
	idec = ffin(1,not)
c loop thru for all files in list
	do 1000 jj = 1,nfiles
	inp = infile(jj)
	ix1 = iix1
c  buffers in data into array  x  using sequential householder
c  rotations on each buffer-load for mean and variance calculations
	r=0.0
	d=0.0
	esq=0.0
	itot=0
	i1=1
	ibuf = buf
c
 2000	n=min0(ix2-ix1+1,ibuf)
        en=n
	if (inp .lt. 0) goto 2005
	call intio(ix,ix1,ix1+n-1,inp,0)
	do 2004 j=1,n
 2004   x(j) = ix(j)
	goto 2010
 2005   call realio(x,ix1,ix1+n-1,inp,0)
 2010   ix1=n + ix1
	em=aint((en-i1+idec)/idec)
	itot=em + itot
	if (r.ne.0.0) go to 2020
	xmax=x(1)
	xmin=xmax
2020	rnorm=sqrt(r*r + em)
	u1=r+sign(rnorm,r)
	r=-sign(rnorm,r)
	wdotu=d*u1
	do 2100 i=i1,n,idec
	xi=x(i)
	xmax=amax1(xi,xmax)
	xmin=amin1(xi,xmin)
 2100	wdotu=xi + wdotu
	c=2.0*wdotu/(em + u1*u1)
	d=d - c*u1
	do 2200 i=i1,n,idec
 2200	esq=(x(i)-c)**2 + esq
	i1=idec - mod(n-i1,idec)
	if (ix1.le.ix2) go to 2000
c
c  job done; print results
	xmean=d/r
	var=esq/itot
	sig=sqrt(var)
c
	write(6,300) inp,itot,xmean,var,sig,xmin,xmax
 300	format(' File # ',i6,/,
     +' no of data',5x,i9,14x,'mean',8x,g13.5/
     +' variance',7x,g13.5,10x,'stan dev',5x,g13.5/
     +' min x',10x,g13.5,10x,'max x',7x,g13.5//)
	call retnio(inp)
 1000   continue
	end
