#include "general.h"

/* This function is different from standard longis(int *) which is */
/* a part of NIOLIB */

long blongis_(filename,fnlength,dummy)
/*  for a given file returns the length in bytes,
    or -1 if the file could not be found or has a different owner and
    is not read-permitted    */

char *filename;
short *fnlength;
int dummy;
{
   long i,terms;
   char fn[NAMLN];
   struct stat finfo;
   for (i=0; i<(*fnlength); i++)
      fn[i] = filename[i];
   fn[i] = '\0';
   if(stat(fn,&finfo)==-1)
      terms = -1;             /*error return on failed status request*/
   else{ 
      if( (getuid()!=finfo.st_uid) && ((finfo.st_mode&04)==0) )
      	 terms = -1;             /*error return on no read permission*/
      else{
         terms = (finfo.st_size - OFFST);
      }
   }
   return(terms);
}
