      subroutine toffs(iflen,idec,is)
      double precision js,ds
      common/time/idat(4),sam
      dimension jdat(4)
c  given a series with start time idat (day,hr,min,sec) and
c  sample interval sam (in seconds), which is to have a filter
c  of total length iflen run over it, and will be decimated by
c  idec, this subroutine returns is, the sample which should
c  be used to start the convolution so that the filtered
c  series will begin at an even multiple of the new sample interval.
c  (e.g, if we are decimating a 5 minute series by 60,
c  the output terms will be on the hour). note that for this
c  to work the filter length must be odd.
c
c   ***calls secdat
c
      call datsec(js,idat,0)
      ds = idec*dble(sam)
      res = dmod(js,ds)
      ioff = (ds-res)/sam + 1
      is = ioff - iflen/2
 3    if(is.gt.0) go to 5
      is = is + idec
      go to 3
 5    js = js + sam*(is-1+iflen/2)
      call secdat(js,jdat)
      do i=1,4
        idat(i)=jdat(i)
      enddo
      write(6,100) jdat
 100  format(' first output point will be at',i4,3i3)
      return
      end

