      subroutine toffs2(iflen,idec,is,iyr)
      double precision js,ds
      common/time/idat(4),sam
      dimension jdat(4)
c  given a series with start time idat (day,hr,min,sec) and
c  year given by iyr and
c  sample interval sam (in seconds), which is to have a filter
c  of total length iflen run over it, and will be decimated by
c  idec, this subroutine returns is, the sample which should
c  be used to start the convolution so that the filtered
c  series will begin at an even multiple of the new sample interval.
c  (e.g, if we are decimating a 5 minute series by 60,
c  the output terms will be on the hour). note that for this
c  to work the filter length must be odd.
c
c   ***calls secdat
c
      call datsec(js,idat,0)
      ds = idec*dble(sam)
      res = dmod(js,ds)
      ioff = (ds-res)/sam + 1
      is = ioff - iflen/2
 3    if(is.gt.0) go to 5
      is = is + idec
      go to 3
 5    js = js + sam*(is-1+iflen/2)

      im= mod(iyr,4) 
      if (im.eq.0) then
	 if (js.ge.31622400) then
	    js=js-31622400
	    iyr=iyr+1
         endif
      else
	 if (js.ge.31536000) then
	    js=js-31536000
	    iyr=iyr+1
         endif
      endif
	 
      call secdat(js,jdat)
      write(6,100) iyr,jdat
 100  format(' first output point will be at',i5,i4,3i3)
      return
      end

