      subroutine secdat(js,kct)
c  takes double precision julian seconds js and converts to
c  days, hours, min, sec in array kct.  jan 1 is day 1
c  but 000001 jan 2 is second 86401
      double precision js,ks
      dimension kct(4)
      ks=js
      kct(1)=ks/86400d00
      ks=ks-86400d00*kct(1)
      kct(1)=kct(1)+1
      kct(2)=ks/3600
      ks=ks-3600.*kct(2)
      kct(3)=ks/60
      kct(4)=ks-60*kct(3)
      return
      end
      subroutine datsec(js,kct,ileap)
c  subroutine converts date in kct (stored as day-number,
c  hour, minute, second) to julian seconds. day number zero is taken
c  to be the last day of the year (365 if ileap is 0, 366 if not).
      double precision js
      dimension kct(4)
      if(kct(1).eq.0)kct(1)=365 +ileap
      js=(kct(1)-1.)*24. + kct(2)
      js=js*60+kct(3)
      js=js*60+kct(4)
      return
      end

