      subroutine arhdpr(tnam)
c    prints out header data, which is passed through in common
c    trof commands are added to make a nice format
c    tnam is the name of the tape that data are to be written to
c
c     $$$$calls many Unix routines - not portable
c
      save ipd
      integer getpid
      character*(*) tnam
      character*65 comman
      character*22 filnam
      character*8 source,chanid
      character*4 stc,commen,ho
      character*1 not
      double precision js,scans,ks,tdi
      dimension kct(4)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      data ho/'////'/,ileap/0/,idum/0/
c  make a unique number for each call
      if(idum.eq.0) then
         ipd = getpid()
         ipd = mod(ipd,1000)
         if(ipd.lt.100) ipd = 666
         idum = 1
      endif
      ipd = ipd + 1
      if(ipd.eq.1000) ipd=100
c    compute number of cal channels
      ncc = 0
      do 1 i=1,4
 1    if(ncal(i).ne.0) ncc = ncc + 1
c    check for inconsistency in times vs. number of scans
      do 2 i=1,4
 2    kct(i) = istart(i+1)
      call datsec(js,kct,ileap)
      do 3 i =1,4
 3    kct(i) = iend(i+1)
      call datsec(ks,kct,0)
c  add in time for intervening years.  ld = # of leap days
      nyr = iend(1) - istart(1)
      ld = (mod(istart(1)-1,4)+nyr)/4
      ks = ks - js +nyr*31536000d00 + ld*86400d00
      tdi = (scans-1.)*sampin
      if(tdi.ne.ks) idum = 1
c            start printing - first get the output file
      iunit=1
      write(filnam,89) ipd
 89   format('/tmp/archlist.',i3)
      open(iunit,file=filnam)
c
      write(iunit,90)
 90   format('.PZ 11',/,'.VS 13',/,'.PO 1i',/,'.LL 7i',/,
     1 '\&',/,'.ST',/,'.sp ',/,'.tl ''''''\*(DY''',/,'.ce 1',/,
     2 '\fB\s+2PFO Header Information\s0\fP',/,
     3 '.sp',/,'.nf',/,'.na')
      write(iunit,91) source
 91   format('.ce 1',/,'Name is  \f[CB]',a8,'\fP',/,'.sp')
      write(iunit,92) tnam
 92   format('Stored on: \fB',a,'\fP',/,'.sp')
      write(iunit,102) int(scans), int(sampin)
 102  format('\fB',i7,'\fP scans, recorded at \fB',i6,
     1 '\fP second intervals',/,'.sp')
      write(iunit,103)istart
 103  format('Start time is \f[CB]',i4,':',i3,3(':',i2),
     1 '\fP')
      write(iunit,104) iend
 104  format('Stop time is  \f[CB]',i4,':',i3,3(':',i2),
     1 '\fP',/,'.sp',/,'.fi',/,'.ad')
      write(iunit,106) nchann
 106  format('.ce 1',/,'\fB',i3,'\fP channels:',/,'.TS',/,
     1 'center;',/,'l l l.'
     2 ,/,'Number	Name	Diskfile',/,'.sp')
      do 11 i = 1,nchann
      ical = 0
      do 5 j=1,4
 5    if(ncal(j).eq.ichnm(i)) ical = 1
      if(ical.eq.0) write(iunit,107) ichnm(i),chanid(i),nchf(i)
 107  format(i3,'	\f[CB]',a8,'\fP	',i6)
      if(ical.ne.0) write(iunit,109) ichnm(i),chanid(i)
 109  format(i3,'	\f[CR]',a8,'\fP')
 11   continue
      write(iunit,108)
 108  format('.TE',/,'.nf',/,'.na',/,'.sp')
      if(commen(1).ne.ho) go to 18
      write(iunit,113)
 113  format('No comments',/,'.sp')
      go to 25
 18   write(iunit,111)
 111  format('Comments:\s-1',/,'.sp',/,'.ft CR')
      do 20 i = 1,10
      if(commen(1+(i-1)*20).eq.ho) go to 25
  20  write(iunit,112) (commen(k),k = 1+(i-1)*20,i*20)
 112  format(20a4)
  25  write(iunit,100) stc,nchf(17)
 100  format('.ft TR',/,'.sp',/,
     1  '\s+1Station code is \fB',a4,'\fP and header is',i5)
      close(iunit)
      write(6,114)
 114  format(' Send header listing to laser printer? (y/n); ',$)
      iunit = ffin(1,not)
      if(not.eq.'y' .or. not .eq. 'Y') then
         write(comman,120) filnam
 120     format('postp ',a22,'&')
         call system(comman)
      else
	 write(6,116) filnam
 116     format('     Listing is in file ',a22)
      endif
      return
      end
