      subroutine headed(idum)
c          allows editing of header data (idum = 0) or cration of a
c          complete new header frim the keyboard (idum = 1)
c
c      calls ffin,listin
c
      character*40 filnam
      character*1 not,iouf
      character*8 source,chanid
      character*4 stc,commen,ho
      double precision scans,js,ks,tdi
      dimension kct(4)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      data ho/'////'/,ifl2/0/,ifl3/0/
      if (idum.eq.0) go to 1000
c          header to be created from scratch - proceed as in idared
c
      write(6,101)
 101  format(' Header file number: ',18x,'; ',$)
      nchf(17) = ffin(1,not)
      write(6,102)
 102  format(' Station code  ',23x,';; ',$)
      read(5,151)  stc
 151  format (a4)
      write(6,103)
 103  format(' Name of source tape  ',16x,';; ',$)
      read(5,152)  source
 152  format (a8)
 2    write(6,104)
 104  format(' Start time (yr,d,h,m,s): ',13x,'; ',$)
      do 3 i = 1,5
 3    istart(i) = ffin(1,not)
      write(6,105)
 105  format(2x,'Stop time (yr,d,h,m,s): ',13x,'; ',$)
      do 4 i = 1,5
 4    iend(i) = ffin(1,not)
      write(6,106)
 106  format(' Sample interval in seconds: ',10x,'; ',$)
      sampin = ffin(1,not)
      write(6,107)
 107  format(' Number of scans: ',21x,'; ',$)
      scans = ffin(1,not)
c           check time of start and stop for consistency
 5    do 10 i = 1,4
 10   kct(i) = istart(i+1)
      call datsec(js,kct,0)
      do 11 i = 1,4
 11   kct(i) = iend(i+1)
      call datsec(ks,kct,0)
c   allow for intervening years (and leap days)
      nyr = iend(1) -istart(1)
      ld = (mod(istart(1)-1,4)+nyr)/4
      ks = ks - js + nyr*31536000d00 + ld*86400d00 
      tdi = sampin*(scans-1.)
      if (ks.eq.tdi) go to 12
      iyr = istart(1)
c         find end time from number of scans
      tdi = tdi + js
 30   ileap = 0
      if(mod(iyr,4).eq.0) ileap= 1
      if(tdi.le.31536000d00+ileap*86400d00)  go to 31
      tdi = tdi - 31536000d00 -ileap*86400d00
      iyr = iyr + 1
      go to 30
 31   call secdat(tdi,kct)
c           find number of scans from start and end times
      js = (ks/sampin) + 1.
 13   write(6,108)  js,iyr,kct
 108  format(11x,' *** TIME INCONSISTENCY ***',/,
     1' For given start and end times, number of scans should be ',f9.0,
     2/,' Alternatively, for the given start time and number of scans,',
     3/,' the end time should be ',5(i4,1x))
      if (idum.eq.1.and.ifl3.eq.0) write(6,150)
 150  format(' Type 0,3 to change the start time, 0,4 for the stop',
     1' time',/,' 0,6 for the number of scans, 0,7 for the sample',
     2' interval,',/,' and 0,0 to continue on when done'/)
      write(6,160)
 160  format(' To exit or continue without having consistency ',
     1  'required, type -1,-1',/)
      ifl3 = 1
      go to 501
 12   if (idum.eq.0) go to 500
      write(6,109)
 109  format(' Clock corrections at start and stop: ',1x,'; ',$)
      clkc(1) = ffin(1,not)
      clkc(2) = ffin(1,not)
 6    write(6,110)
 110  format(' Number of channels which header will reference:; ',$)
      nchann = ffin(1,not)
      write(6,111)
 111  format(' Their id numbers:; ',$)
      call listin(ichnm,nddd,nchann)
c  find which channels are cal channels
 7    write(6,1175)
 1175 format(' Number of cal channels; ',$)
      ncc = ffin(1,not)
      if(ncc.eq.0) go to 88
      if(ncc.lt.0.or.ncc.gt.4) go to 7
      write(6,1176)
 1176 format(' Their numbers; ',$)
      call listin(ncal,nddd,ncc)
 88   write(6,112)
 112  format(' Files where the data channels are:  ')
      do 15 i = 1,nchann
      if(ncalcm(ichnm(i),ncal,4).eq.1) go to 15
      write(6,114)  ichnm(i)
      nchf(i) = ffin(1,not)
 15   continue
      write(6,113)
 113  format(' Names of channels (max 8 characters per name)',/)
      do 16 i = 1,nchann
      write(6,114)  ichnm(i)
 114  format(11x,' Channel ',i3,';; ',$)
      read(5,115)  chanid(i)
 115  format(a8)
 16   continue
      if (idum.eq.0) go to 9
      write(6,116)
 116  format(' Scans/block (if not 1, cal channels cannot be',
     1 ' written to tape):; ',$)
      iblock = ffin(1,not)
 9    do 17 i = 1,4
 17   calc(i) = 0
      if(ncc.eq.0) go to 20
      write(6,117)
 117  format(' Average value of data in cal channels: ',/)
      do 19 i = 1,ncc
      write(6,118) ncal(i)
 118  format(10x,'Channel ',i3,':; ',$)
      calc(i) = ffin(1,not)
 19   continue
 20   if (idum.eq.0) go to 501
 8    write(6,119)
 119  format(' The space available for comments is 10 lines, each 80',
     1' characters long.',/,' An 80-character line extends to ',
     2 'the edge of the screen.',/,
     3 ' To terminate comments, begin a new line with a ////',/)
      write(6,120)
 120  format(' Do you want to read the comments from another file'
     1,' (y/n)?; ',$)
      ixxx = ffin(1,iouf)
      if(iouf.eq.'n'.or.iouf.eq.'N') then
         ixxx=5
         write(6,121)
 121     format(' Enter the comments:',/)
      endif
      if(iouf.eq.'y'.or.iouf.eq.'Y') then
	 if(iouf.eq.'Y') write(6,122)
 122     format('IS YOUR TERMINAL IN LOWERCASE?')
         ixxx = 1
         write(6,123)
 123     format(' Name of file;; ',$)
         read(5,124) filnam
 124     format(a)
         open(ixxx,file=filnam)
      endif
      do 21 i = 1,10
      read(ixxx,125,end=22)  (commen(j), j=1+20*(i-1), i*20)
 125  format (20a4)
      if(commen(1+20*(i-1)).eq.ho) go to 22
 21   continue
 22   if(iouf.eq.'y'.and.i.le.10) commen(1+20*(i-1)) = ho
      if(iouf.eq.'y') then
         close(ixxx)
         write(6,126)
 126     format(' Comments read in are:'/)
         do 23 i = 1,10
         if(commen(1+20*(i-1)).eq.ho) go to 24
         write(6,125)  (commen(j), j=1+20*(i-1), i*20)
 23      continue
 24      write(6,127)
 127     format(/' Is this ok? (y/n); ',$)
         ixxx = ffin(1,not)
         if(not.eq.'n') go to 8
      endif
      if (idum.eq.0) go to 501
      return
c
c         header to be edited - proceed piecemeal (using many formats and
c               some code from part above
c
 1000 write(6,201)
 201  format(' For instructions on using the editor, type 1 ; ',$)
      ifl = ffin(1,not)
      if (ifl.ne.1) go to 501
      write(6,202)
 202  format(' To prepare to edit, you must enter 2 numbers that',
     1' specify what you want to change. ',/,' If the first number',
     2' is zero the second indicates which header item you want to',
     3' change.'/'If the first number is n, it means that you want',
     4' to do something to the channel which is n-th in order.',/,
     5' The second number then specifies just what you want to do.'/)
      write(6,203)
 203  format(2x,'First number:',20x,1h0,34x,1hn,//)
      write(6,204)
 204  format(' 2nd number and changes: ',/)
      write(6,301)
 301  format(36x,'1 - station code',18x,'1 - channel number of nth',
     1' channel'/36x,'2 - name of source tape',11x,'2 - name of nth ',
     2'channel'/36x,'3 - start time',20x,'3 - file number: n-th channel'
     3/36x,'4 - stop time'/36x,'5 - clock corrections'/36x,'6 - number',
     4' of scans'/36x,'7 - sample interval'/36x,'8 - scans/block (1 ',
     5'if 13-16 are not cal channels)',/,36x,'9 - number of channels',
     6/36x,'10 - average values in cal channels',/,36x,'11 - comments'
     7/36x,'12 - header file number',//)
      write(6,205)
 205  format(' To add or delete one or more channels, begin by',
     1' changing the number of channels appropriately.',/,
     2' The program will then ask for all the channel ',
     3'information to be input.'/)
      write(6,206)
 206  format('   0 0 terminates run.')
 501  write(6,207)
 207  format(' Which item do you wish to change? ; ',$)
      if1 = ffin(1,not)
      if2 = ffin(1,not)
      ifl2 = 0
      if(if1.lt.0) go to 12
      if (if1.ne.0) go to 700
c         check time before leaving
      if (if2.eq.0) go to 5
      go to (601,602,603,604,605,606,607,608,609,610,611,612) if2
 601  write(6,102)
      read(5,151)  stc
      go to 501
 602  write(6,103)
      read(5,152) source
      go to 501
 603  write(6,104)
      do 502 i = 1,5
 502  istart(i) = ffin(1,not)
      go to 501
 604  write(6,105)
      do 503 i = 1,5
 503  iend(i) = ffin(1,not)
      go to 501
 605  write(6,109)
      clkc(1) = ffin(1,not)
      clkc(2) = ffin(1,not)
      go to 501
 606  write(6,107)
      scans = ffin(1,not)
      go to 501
 607  write(6,106)
      sampin = ffin(1,not)
      go to 501
 608  write(6,116)
      ibl = ffin(1,not)
      if(ibl.ne.1.and.iblock.eq.1) ifl2 = 1
      iblock = ibl
      if (ifl2) 501,501,610
 609  write(6,208)
 208  format(' Changing the number of channels requires all channel ',
     1'information to be retyped. ',/,' If you want a listing of the ',
     2' present channel data, type 1 ; ',$)
      iflp = ffin(1,not)
      if (iflp.ne.1) go to 6
      do 511 i = 1,nchann
      if(ncalcm(ichnm(i),ncal,4).eq.0) write(6,209)  ichnm(i),
     1  chanid(i), nchf(i)
 209  format(9x,'Channel   ',i3,'    is called   ',a8,
     1 '    and is on diskfile   ',i6)
      if(ncalcm(ichnm(i),ncal,4).eq.1) write(6,2091) ichnm(i),chanid(i)
 2091 format(9x,'Channel   ',i3,'    is called   ',a8)
 511  continue
      if (ncc.eq.0) go to 513
      do 512 i = 1,4
      if(ncalcm(ncal(i),ichnm,nchann).ne.0) write(6,210) ncal(i),calc(i)
 210  format(' Average value in channel  ',i3,'  is  ',f7.2)
 512  continue
 513  write(6,211)
 211  format(1x)
      go to 6
 610  write(6,1175)
      ncc = ffin(1,not)
      if(ncc.eq.0) go to 501
      if(ncc.lt.0.or.ncc.gt.4) go to 610
      write(6,1176)
      call listin(ncal,nddd,ncc)
      write(6,117)
      do 515 i=1,ncc
      write(6,118)  ncal(i)
      calc(i) = ffin(1,not)
 515  continue
      go to 501
 611  go to 8
 612  write(6,101)
      nchf(17) = ffin(1,not)
      go to 501
c          section below handles changes to individual channels
c
 700  if(if2.ne.2.or.ncalcm(ichnm(if1),ncal,4).ne.1) go to 701
      write(6,800)
 800  format(' There are no disk files for cal channels ')
      go to 501
 701  write(6,801)  ichnm(if1), if1
 801  format(' Channel number ',i3,' is ',i3,' in sequence ',$)
      if (if2-2) 702,704,703
 702  write(6,802)
 802  format('New channel number is; ',$)
      ichnm(if1) = ffin(1,not)
      go to 501
 703  write(6,803)  nchf(if1)
 803  format('Formerly on diskfile ',i6,'. to be on file; ',$)
      nchf(if1) = ffin(1,not)
      go to 501
 704  write(6,804)  chanid(if1)
 804  format('Formerly called ',a8,'. renamed;; ',$)
      read(5,805)   chanid(if1)
 805  format(a8)
      go to 501
 500  return
      end
      function ncalcm(ic,nc,n)
      dimension nc(n)
      ncalcm = 0
      do 1 i=1,n
 1    if(nc(i).eq.ic) ncalcm = 1
      return
      end
