      subroutine headpr(idum)
c    prints out header data, which is passed through in common
c    returns idum = 0 unless times are inconsistent, in which
c    case returns idum = 1
      character*8 source,chanid
      character*4 stc,commen,ho
      character*4 filnam
      character*1 wm
      double precision js,scans,ks,tdi
      dimension kct(4)
      common/wdump/idump,wm
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
C old    common/head/stc,source,calc(4),clkc(2),nchann,iblock,istart(5)
C old   1     iend(5),scans,sampin,nchf(17),ichnm(16),chanid(16),ncal(4)
C old   2     commen(200
      data ho/'////'/,ileap/0/
      idum = 0
      if(idump.eq.0) then
         lu=6
      else
	 lu=2
	 write(filnam,95) idump
 95      format('c',i3)
	 open(lu,file=filnam)
      endif
c    compute number of cal channels
      ncc = 0
      do 1 i=1,4
 1    if(ncal(i).ne.0) ncc = ncc + 1
c    check for inconsistency in times vs. number of scans
      do 2 i=1,4
 2    kct(i) = istart(i+1)
      call datsec(js,kct,ileap)
      do 3 i =1,4
 3    kct(i) = iend(i+1)
      call datsec(ks,kct,0)
c  add in time for intervening years.  ld = # of leap days
      nyr = iend(1) - istart(1)
      ld = (mod(istart(1)-1,4)+nyr)/4
      ks = ks - js +nyr*31536000d00 + ld*86400d00
      tdi = (scans-1.)*sampin
      if(tdi.ne.ks) idum = 1
c            start printing
      if(wm.ne.'c') then
        write(lu,100) nchf(17)
 100  format(' Header data contained on file ',i7,':',//)
        write(lu,101) stc, source
 101  format(' Data from station ',a4,' recorded on cassette called ',
     1     a8,/)
        write(lu,102) scans, sampin
 102  format(3x,f8.0,' scans, recorded at ',f6.0,'-second intervals',/)
        write(lu,103)istart,clkc(1)
 103  format(' First scan is at ',i4,':',i3,3(':',i2),
     1 ' (clock corr. ',f4.1,')')
        write(lu,104) iend, clkc(2)
 104  format('  Last scan is at ',i4,':',i3,3(':',i2),
     1 ' (clock corr. ',f4.1,')')
        if(idum.ne.0) write(lu,105)
 105  format(/,'  *********NUMBER OF SCANS IS INCONSISTENT WITH TIMES',
     1    ' GIVEN**********',/)
        write(lu,106) nchann
 106  format(/,1x,i3,' channels recorded, videlicet:',/)
        do 11 i = 1,nchann
        ical = 0
        do 5 j=1,4
 5      if(ncal(j).eq.ichnm(i)) ical = 1
        if(ical.eq.0) then
	   write(lu,107) ichnm(i),chanid(i),nchf(i)
 107       format(' Channel ',i3,', which is named  ',a8,
     1   ', and is on diskfile ',i6)
           lenact = longis(nchf(i))
	   if(lenact.ne.scans) write(lu,1071) nchf(i),lenact
 1071      format(9x,'***FILE ',i6,' IS ACTUALLY ',i10,' SCANS LONG***')
        endif
        if(ical.ne.0) write(lu,109) ichnm(i),chanid(i)
 109  format(' Channel ',i3,', which is named  ',a8)
 11     continue
        if (ncc.ne.0) then
           write(lu,108)
 108       format(/,' Average values of data on ',
     1               'calibration channels: ',/)
           do 13 i = 1,4
 13        if(ncal(i).ne.0) write(lu,110) ncal(i), calc(i)
 110     format (' Channel ',i3,':',f9.2,10x,$)
	endif
        write(lu,666)
      endif
      if(commen(1).eq.ho) then
         write(lu,113)
 113     format(' no comments'/)
         return
      endif
      if(wm.ne.'c') write(lu,111)
 111  format(' comments:',/)
      do 20 i = 1,10
      if(commen(1+(i-1)*20).eq.ho) go to 66
  20  write(lu,112) (commen(k),k = 1+(i-1)*20,i*20)
 112  format(20a4)
 66   write(lu,666)
 666  format(/)
      return
      end
