      subroutine curs(n,nst,ix,iy,nfl,ity)
c   if ity gt 0 reads cursor position using rdcur
c   and uses typed-in letter to set nfl with number of
c   corresponding entry in nst (to give commands) and also
c   returns cursor position as ix,iy.  if ity le 0 prints prompt,
c   reads single-letter command and sets nst as appropriate.
c   in both cases resets pointer to left hand side of screen,
c   spacing down appropriately according to value of isp
c
c    calls rcur12, send12, resett (in grafic)
      character*1 nc,nst
c
      dimension nst(*)
c   common block to control spacing - reset isp to 3 each time
c   screen is erased, and increment if printing is  done
c   outside subroutine.
      common/tkcon/isp,nmsec
 1    if(ity.le.0) go to 2
      call send12(-13,0,0)
      call send12(0,0,-1)
      call rcur12(ix,iy,nc)
c   clear buffer
 2    call resett(isp)
      isp = isp + 1
      if(ity.le.0) write(6,100)
 100  format(1x,'*',$)
      if(ity.le.0) read (5,102) nc
 102  format(a1)
c   scan through commands
      do 3 nfl = 1,n
      if(nc.eq.nst(nfl)) return
 3    continue
      if(ity.gt.0) write(6,104)
 104  format(' beg pardon? ')
      if(ity.le.0) write(6,106)
 106  format(' what? ')
      if(ity.le.0) isp = isp + 1
      go to 1
      end
