      program dbydt
c   program to use krner to create a differentiator with zero
c  phase shift
c
c    calls krner,firres,realio
c
      dimension wts(200),ew(200)
      data wts/200*0./,ifl1/0/,ew/200*0./
      write(6,100)
 100  format(' Nyquist frequency ; ',$)
      fny = ffin(1,not)
      sc = 1./fny
      to = 1./(2.*fny)
 3    write(6,102)
 102  format(' Attenuation, corner position, transition width ; ',$)
      db = ffin(1,not)
      ce = sc*ffin(1,not)
      wd = sc*ffin(1,not)
      call krner(db,ce,wd,be2,0,5,99,np,wts(101))
      write(6,104) 2*np+1
 104  format(i5,' weights. type 1 if ok ; ',$)
      iok = ffin(1,not)
      if(iok.ne.1) go to 3
 5    write(6,106)
 106  format(' Start, end, interval frequency ; ',$)
      sf = ffin(1,not)
      ef = ffin(1,not)
      fi = ffin(1,not)
      if(fi.eq.0) go to 9
      nf = (ef-sf)/fi + 1
      do 7 i = 1,nf
      fr = sf + (i-1)*fi
      fn = .5*sc*fr
      nn = np + 1
      call firres(ew,wts(101),nn,1,1,fn,amp)
      db = 20.*alog10(amp+1.e-25)
      write(6,108) fr,amp,db
 108  format(2x,g13.5,g15.7,f7.1)
 7    continue
      go to 5
 9    if(ifl1.eq.1) go to 17
      ifl1 = 1
      write(6,110)
 110  format(' Normalizing frequency (<0 to use interval) ; ',$)
      fi = .5*sc*ffin(1,not)
      if(fi.eq.0) go to 13
      call firres(ew,wts(101),np+1,1,1,fi,amp)
      do 11 i = 1,np
      wts(101-i) = -wts(101+i)/amp
 11   wts(101+i) = wts(101+i)/amp
      go to 5
 13   write(6,111)
 111  format(' Interval over which rates wanted (in same units as',
     1 ' nyquist) ; ',$)
      tr = ffin(1,not)
      r = tr/to
      do 15 i=1,np
      wts(101-i) = -r*wts(101+i)
 15   wts(101+i) = r*wts(101+i)
      go to 5
 17   write(6,112)
 112  format(' Output file (real): ; ',$)
      iou = ffin(1,not)
      nr = 2*np + 1
c     nf = (rn+59)/60
      call realio(wts(101-np),1,nr,iou,1)
      stop
      end
