c   program edtoasc
c
c     converts from binary (iolib) to ascii versions of edits file
c
c   calls timsubs, edcon3, headco
c
      character*20 dumm
      character*8 source,chanid
      character*4 stc,commen
      double precision scans
      character*1 reason,mode
      dimension igap(2,4000),ioff(4000),reason(4000)
      dimension lgp(5),lfgp(5)
      dimension mgp(6),mfgp(6),istm(6)
      common/head/scans,calc(4),clkc(2),sampin,nchann,iblock,istart(5),
     1     iend(5),nchf(17),ichnm(16),ncal(4),source,chanid(16),stc,
     2     commen(200)
      common /scanrem/irc
      data reason/4000*'.'/,mode/'d'/,len/0/,ned/4000/
c
c  get information from command line
c
      if(iargc().ne.4) call userr
      call getarg(1,dumm)
      read(dumm,100) ifl
 100  format(i6)
      if(ifl.lt.0) call userr
      call getarg(2,dumm)
      read(dumm,100) ifh
      if(ifh.lt.0) call userr
      call headco(ifh,1)
      isamp=sampin
      call getarg(3,mode)
      if(mode.ne.'d'.and.mode.ne.'m') call userr
      if(mode.eq.'m') then
         call toymd(istart,istm)
         do i=3,5
           istm(i+1)=istart(i)
         enddo
      endif
c
c  to write out ASCII, need to get the information for a channel
c
      call getarg(4,dumm)
      read(dumm,100) ichw
      ich=0
      do i=1,nchann
        if(ichnm(i).eq.ichw) ich=i
      enddo
      if(ich.eq.0) then
        write(6,102) ichw,ifh
 102    format('Channel number ',i4,' not found in header ',i6)
        stop
      endif
      call edcon3(ifl,ned,igap,ioff,1,len)
      do i=1,ned
C         if(igap(2,i).le.scans) then
           if(mode.eq.'d') then
             call timfnd(istart,igap(1,i)-1,isamp,lgp,mode)
             call timfnd(istart,igap(2,i)-1,isamp,lfgp,mode)
             write(6,104) stc,chanid(ich),lgp,lfgp,ioff(i),reason(i)
 104         format(1x,a4,1x,a8,1x,i4,i4,3i3,3x,i4,i4,3i3,2x,i8,2x,a1)
           endif
           if(mode.eq.'m') then
             call timfnd(istm,igap(1,i)-1,isamp,mgp,mode)
             call timfnd(istm,igap(2,i)-1,isamp,mfgp,mode)
             write(6,106) stc,chanid(ich),mgp,mfgp,ioff(i),reason(i)
 106         format(1x,a4,1x,a8,1x,i4,5i3,3x,i4,5i3,2x,i8,2x,a1)
           endif
C         endif
      enddo
      stop
      end
      subroutine userr
c
c  error message, giving usage
c
      write(6,100)
 100  format(/,'Usage:',/,
     3 '       edtoasc edfilnum headerfilnum tmode chnum >',
     4 ' ascii-edits ',//,
     5 ' to convert to an edits file in ASCII from one in binary',/,
     6 '   (iolib), using the timing information in the',
     7 ' header file',/,
     8 ' tmode must be m or d, for ascii as y-m-d or y-d respectively',/,
     8 ' only edits in range covered by header will be written out',
     9 /)
      stop
      end
