c  program to generate a command file "squegee" that will
c  delete blocks of data files in standard niolib form.
c  program recognizes file-naming conventions that relate
c  file numbers above 1000 to long integer files,
c  and that negative file numbers imply real number files.
c
c    $$$$calls listin, chmod
c
      character*1 iyes,ir
      dimension list(201),ir(3)
      data ir/'R','I','L'/
      write(6,100)
 100  format(' do you want instructions? (yes,no); ',$)
      read (5,105) iyes
 105  format(a1)
      if (iyes.eq.'y') write(6,115)
 115  format(/' Enter a list of file numbers to be removed.'
     &/' Separate the numbers by spaces or commas.'
     &/' To delete all files between 120 and 130 (for example)'
     &/' enter 120 to 130. To terminate the list enter 0')
c  read in list of files
      write(6,116)
 116  format(/' Enter the list of file numbers')
      l = -1
      call listin(list,l,0)
c  input finished.  now list file numbers
 2000 if (list(l).eq.0) l=l - 1
      write(6,200) (list(i),i=1,l)
 200  format(/' input terminated'
     &/' list of file numbers to be deleted'
     &/(10i5))
c  create command file
      open(unit=iu,file='squegee')
      do 2500 i=1,l
      iri = (list(i)+1000)/1000 + 1
      ifile = mod(iabs(list(i)),1000)
      write(iu,230) ir(iri),ifile
 230  format('rm ',a1,i3,'.D')
 2500 continue
c  all done - now delete command file itself
      write(iu,260)
 260  format('rm squegee')
      idum = chmod('squegee','+x')
      write(6,300)
 300  format(/' command file generated ',
     &/' to delete files enter squegee')
      stop
      end
