      program merged
c     combines edits files into a new file, with at most 300 edits
c    any number of files may be combined. the rule for combination is
c    that if any edits file shaow a point as bad, the final file will.
c    if one edit falls entirely within another, the offset specified in
c    the shorter edit is ignored; if two edits partly overlap, their
c    offsets are added.
c
c    calls edcon
c
      dimension iedin(2,2,2000),iedot(2,2000),iof(2,2000),ioft(2000),
     1 ndc(2),ned(2)
      common/minedt/mlen
      data ned/2*2000/,ntplen/480/,mbufsz/2000/
 61   write(6,100)
 100  format(' length of data file (<0 for help)    ; ',$)
      irnt = ffin(1,not)
      if(irnt.gt.0) go to 62
      write(6,101)
 101  format(
     1' after you answer the preliminary questions, the program will',/,
     2' ask for edits files. enter the files to be merged. when you'/
     3' have entered all there are (which may be only one if you are'/
     4' simply padding out a file), enter a file number of 0 and then'/
     5' the number of the output edits file')
      go to 61
 62   write(6,102)
 102  format('type 1 to add offsets in embedded files (usually 1); ',$)
      iadd = ffin(1,not)
      write(6,104)
 104  format(' min length of output edits-file (-1 if file will',
     1 ' go on tape); ',$)
      mlen = ffin(1,not)
      if(mlen.lt.0) mlen = ntplen
      call edcon4(ned(1),iedot,ioft,1,irnt)
      nt = ned(1)
      do 1 i=1,ned(1)
      iedin(1,1,i) = iedot(1,i)
      iedin(1,2,i) = iedot(2,i)
 1    iof(1,i) = ioft(i)
 3    call edcon4(ned(2),iedot,ioft,1,irnt)
      if(ned(2).eq.0) go to 21
      do 4 i=1,ned(2)
      iedin(2,1,i) = iedot(1,i)
      iedin(2,2,i) = iedot(2,i)
 4    iof(2,i) = ioft(i)
      nt = 1
      ndc(1) = 1
      ndc(2) = 1
c at this point compare start points of the next edits to be looked
c  at (one from each series), and set ifl to be the index to the
c  one which starts first (the 'lower' one). load this start point
c  into the output array
 5    ifl = 1
      if(iedin(1,1,ndc(1)).gt.iedin(2,1,ndc(2))) ifl = 2
      ifh = 3 - ifl
      iedot(1,nt) = iedin(ifl,1,ndc(ifl))
 7    if(iedin(ifl,2,ndc(ifl)).ge.iedin(ifh,1,ndc(ifh))) go to 9
c  edits do not overlap (start of higher falls after end of lower),
c  so copy all of lower, bump the counter for it up, and loop.
      iedot(2,nt) = iedin(ifl,2,ndc(ifl))
      ioft(nt) = iof(ifl,ndc(ifl))
      ndc(ifl) = ndc(ifl) + 1
      nt = nt + 1
      iff = ifh
      if(ndc(ifl).gt.ned(ifl)) go to 15
      go to 5
 9    if(iedin(ifh,2,ndc(ifh)).gt.iedin(ifl,2,ndc(ifl))) go to 11
c  higher edit is within lower - discard it (but add offset if requested)
c  and loop
      if(iadd.eq.1)
     1    iof(ifl,ndc(ifl)) = iof(ifh,ndc(ifh)) + iof(ifl,ndc(ifl))
      ndc(ifh) = ndc(ifh) + 1
      iff = ifl
      if(ndc(ifh).gt.ned(ifh)) go to 13
      go to 5
c  edits overlap - use upper end of higher (which is the later one)
c  as the new end, add offsets, switch flags, and look at the next edit
c  in the other series (previously the 'lower' series, now the 'higher')
 11   iof(ifh,ndc(ifh)) = iof(ifh,ndc(ifh)) + iof(ifl,ndc(ifl))
      ifl = ifh
      ifh = 3 - ifl
      ndc(ifh) = ndc(ifh) + 1
      iff = ifl
      if(ndc(ifh).gt.ned(ifh)) go to 13
      go to 7
c one edits file is exhausted - finish up from the other one
c 13 is the entry point if we have not put the end on yet, 15 if we have;
c iff is the index showing which edits are not exhausted
 13   iedot(2,nt) = iedin(iff,2,ndc(iff))
      ioft(nt) = iof(iff,ndc(iff))
      nt = nt + 1
      ndc(iff) = ndc(iff) + 1
c  copy edits over, looping until exhausted
 15   if(ndc(iff).gt.ned(iff)) go to 17
      iedot(1,nt) = iedin(iff,1,ndc(iff))
      iedot(2,nt) = iedin(iff,2,ndc(iff))
      ioft(nt) = iof(iff,ndc(iff))
      nt = nt + 1
      ndc(iff) = ndc(iff) + 1
      go to 15
 17   nt = nt - 1
c  shift edits into one part of input array
      do 19 i=1,nt
      iedin(1,1,i) = iedot(1,i)
      iedin(1,2,i) = iedot(2,i)
 19   iof(1,i) = ioft(i)
      ned(1) = nt
      ned(2) = mbufsz
      go to 3
c  all done - write out final file
 21   if(nt.gt.mbufsz) then
	 write(6,108) nt, mbufsz
 108     format(' Total of ',i3,' edits, which exceeds buffer size of '
     1 ,i3,' no output written')
	 stop
      endif
      if(nt.gt.ntplen.and.mlen.eq.ntplen) then
	 write(6,110) nt, ntplen
 110     format(' Total of ',i3,' edits, which EXCEEDS standard '
     1,'tape edits file size of ',i3)
      endif
      call edcon4(nt,iedot,ioft,-1,irnt)
      stop
      end
