c   program termfnd
c
c      given a mode (d or m), start time (y,d,h,m,s for mode d, y,m,d,h,m,s
c    for mode m) and sample interval (sec) on the command line, reads in more
c    times from the standard input, and writes term numbers
c    on the standard output
c
c      calls scansp, getarg (the latter is Unix)
c
      character*40 arg
      character*1 mode
      dimension ist(6),iloc(6)
      if(iargc().lt.6) then
        write(6,100)
 100    format(/,'Usage: termfnd d yr day hr min sec   samp',/,
     1           '  or   termfnd m yr mon day hr min sec   samp',/,
     2           '    reads times from standard input',/)
        stop
      endif
      call getarg(1,arg)
      read(arg,*) mode
      if(mode.eq.'m') narg = 7
      if(mode.eq.'d') narg = 6
      if(iargc().ne.narg+1) then
        write(6,100)
        stop
      endif
      do 3 i=2,narg
      call getarg(i,arg)
      read(arg,*) ist(i-1)
 3    continue
      call getarg(narg+1,arg)
      read(arg,*) isam
 5    read(5,*,end=7) (iloc(i),i=1,narg-1)
      iscans = 1 + iscnsp(ist,iloc,isam,mode)
      write(6,102) iscans
 102  format(i10)
      go to 5
 7    stop
      end
