      subroutine tkplot(y,ia,ib,ymin,ymax)
c
c     this is a new version of the old standby
c
c     originally coded by j farrell  nov, 1978 to use plot10tcs
c     routines
c
c     date and time added to caption by farrell, sept 1979.
c
c     reworked by agnew, oct 1980, to remove plot10tcs routines and
c     use instead a few primitives, and also be easily convertible
c     to unenhanced graphics
c
c     converted to rsx form (old fortran) by agnew, oct 81
c
c     converted to BSD4.2 by agnew, aug 85
c
c*************************************************************
      character*24 dstr
      dimension y(1),xbox(2),ybox(2),spsz(4),rlfz(4)
      common/sam/irbs,ires,ierase, icap
c    data statement giving the coordinates of the box within
c    which the data is displayed and the assumed size of the
c    screen (these must be in the same units, which here are
c    pixels for a screen with enhanced graphics), and the
c    character size to be used.
      data xbox,ybox,bxsc,isize/10.,4011.,65.,2860.,4096.,4/
c    the next data statement gives (in order)
c       the size of the screen (x, then y) in pixels
c       the coordinates of the home position
c       the size of a space, for the four character sizes
c           in the order of the arguments to chrbig
c           (which is, very nearly, the character height also)
c       the size of a line feed, for the four character sizes
c           (note that only one character size is available on
c           tektronix models 4010 and 4012).
c    the appropriate statement should be uncommented, depending on
c    the terminal type and whether or not enhanced graphics are used.
c
c    data for tektronix 4014 with enhanced graphics
      data ixtp,iytp,ixhm,iyhm,spsz,rlfz
     1  /4096,3120,0,3071,56.,51.,34.,31.,88.,82.,53.,48./
c    data for tektronix 4014 without enhanced graphics
c      data ixtp,iytp,ixhm,iyhm,spsz,rlfz
c     1  /1024,780,0,767,14.,12.75,8.5,7.75,22.,20.5,11.25,12./
c    data for tektronix 4012/4010
c      data ixtp,iytp,ixhm,iyhm,spsz,rlfz
c     1  /1024,780,0,767,14.,14.,14.,14.,22.,22.,22.,22./
c      kwwwww = i1mach(2)
      kwwwww = 6
      call chrbig(isize)
      if (ierase.gt.0) go to 10
c  erase screen and send nulls to give it time to recover
      call sendeg(-9,0,0)
      do 5 i=1,96
 5    call sendeg(-10,0,0)
   10 yn = ymin
      yx = ymax
c
c     scan for limits if ymin > or = ymax
c
      if(yx.gt.yn) go to 333
      yn = y(ia)
      yx = y(ia)
  333 do 80 j=ia,ib
      yn = amin1(yn,y(j))
   80 yx = amax1(yx,y(j))
      if(ierase .gt. 0)go to 100
c
c     write caption (previous screen erase will have homed alpha cursor)
c
      write(kwwwww,200) icap,irbs,ires,yn,yx
 200  format('  File ',i6,//,3x,'L= ',i10,' R= ',i10,' B= ',g12.5,
     1  ' T= ',g12.5)
c
c    go to lower left corner (in and out of graph mode) and write date
c
      call sendeg(int((25./bxsc)*ixtp),int((25./bxsc)*ixtp),2)
      call sendeg(-11,0,0)
      call sendeg(0,0,-1)
      call fdate(dstr)
      write(kwwwww,202) dstr
 202  format(1x,a24)
c
c    draw box
c
      call sendeg(int((xbox(1)/bxsc)*ixtp),int((ybox(1)/bxsc)*ixtp),2)
      call sendeg(int((xbox(1)/bxsc)*ixtp),int((ybox(2)/bxsc)*ixtp),1)
      call sendeg(int((xbox(2)/bxsc)*ixtp),int((ybox(2)/bxsc)*ixtp),1)
      call sendeg(int((xbox(2)/bxsc)*ixtp),int((ybox(1)/bxsc)*ixtp),1)
      call sendeg(int((xbox(1)/bxsc)*ixtp),int((ybox(1)/bxsc)*ixtp),1)
 100  xfac = ((xbox(2)-xbox(1))*ixtp/bxsc)/(ib-ia)
      yfac = ((ybox(2)-ybox(1))*ixtp/bxsc)/(yx-yn)
      xedg = (xbox(1)/bxsc)*ixtp
      yedg = (ybox(1)/bxsc)*ixtp
      ix = xedg
      iy = (y(ia)-yn)*yfac + yedg
      call sendeg(ix,iy,2)
      do 150 i=ia+1,ib
      ix = (i-ia)*xfac + xedg
      iy = (y(i)-yn)*yfac + yedg
 150  call sendeg(ix,iy,1)
c
c     go to home position, return to alpha mode, and flush buffer
c
      call sendeg(ixhm,iyhm,2)
      call sendeg(-11,0,0)
      call sendeg(0,0,-1)
c
c      send enough carriage returns to get to top of second column
c
      icrn = iytp/rlfz(isize) - 1
      do 160 i=1,icrn
      write(kwwwww,210)
 210  format(1x)
 160  continue
      ierase = 0.
      return
      end
